routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\PostController;
use App\Http\Controllers\AdminController;
use App\Http\Controllers\ProvinceController;
use App\Http\Controllers\AreaController;
use App\Http\Controllers\StoreController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\SubtagController;
use App\Http\Controllers\ColorController;
use App\Http\Controllers\sizeController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ImageUploadController;
use App\Http\Controllers\frontcontroller;










/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', [frontcontroller::class, 'index']);


Auth::routes();



Route::get('/home', [HomeController::class, 'index'])->name('home');

//admin route
Route::group(['middleware' => ['auth']], function() {
    Route::resource('users', UserController::class);
    Route::resource('roles', RoleController::class);
    Route::resource('permissions', PermissionController::class);
    Route::resource('posts', PostController::class);
    Route::resource('province', ProvinceController::class) ;
    Route::resource('area', AreaController::class) ;
    Route::resource('store', StoreController::class) ;
    Route::resource('tag', TagController::class) ;
    Route::resource('subtag', SubtagController::class) ;
    Route::resource('color', ColorController::class) ;
    Route::resource('size', sizeController::class) ;
    Route::resource('product', ProductController::class) ;

});

//front route
Route::get('/stores',[frontcontroller::class, 'store'])->name('store');
Route::get('/subtagshow/{id}',[frontcontroller::class, 'subtagshow'])->name('subtag'); // Show All subtags store
Route::get('/products',[frontcontroller::class, 'products'])->name('products');  // Show All Product
Route::get('/product_detail/{id}',[frontcontroller::class, 'product_detail'])->name('product_detail'); // show one product

//cart
Route::get('cart', [ProductController::class, 'cart'])->name('cart');
Route::get('add-to-cart/{id}', [ProductController::class, 'addToCart'])->name('add.to.cart');
Route::patch('update-cart', [ProductController::class, 'updatecart'])->name('update.cart');
Route::delete('remove-from-cart', [ProductController::class, 'removecart'])->name('remove.from.cart');
Route::get('product-checkout', [ProductController::class, 'productcheckout'])->name('product-checkout');


// Route::resource('/{page}', AdminController::class);

Route::get('/', function () {
    $provinces = App\Models\province::all();
    return view('indexss',['provinces' => $provinces]);
});

Route::get('getarea/{id}', function ($id) {
    $area = App\Models\area::where('province_id',$id)->get();
    return response()->json($area);
});

app/Models/store.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Traits\Multitenantable;

class store extends Model
{
    use HasFactory ;

    protected $fillable = ['name','address','phone','photo','area_id','user_id'];




public function area()
{
    return $this->belongsTo(area::class);
}


public function user()
{
    return $this->belongsTo(user::class);
}

public function tags()
{
    return $this->belongsToMany(tag::class,'store_tags');
}

public function products()
{
    return $this->hasMany(product::class);
}


public function getfeaturedAttribute($photo)
{
    return asset($photo);// مشان اقدر حط الصورة بس هيك $item->phto      بدل هي=> {{URL::asset($item->photo) }}
}


}

app/Http/Controllers/StoreController.php
<?php

namespace App\Http\Controllers;

use App\Models\area;
use App\Models\store;
use App\Models\tag;
use App\Models\User;

use Illuminate\Http\Request;
use Intervention\Image\ImageManagerStatic as Image;
use session;

use Illuminate\Auth\Events\Validated;

class StoreController extends Controller
{

    public function index()
    {

        $stores = store::orderBy('id')->paginate(5);
        return view('store.index', compact('stores'));
    }

    public function create()

    {

        $areas = area::all();
        $tags = tag::all();
        $users = User::all();


      if($tags->count() == 0)
    {
return redirect()->route('tag.create');
    }

if($areas->count() == 0)
    {
return redirect()->route('area.create');
    }



        return view('store.create')
        ->with('areas', $areas)
        ->with('tags', $tags)
        ->with('users', $users);

    }


    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'area_id' => 'required',
            'tags' => 'required',
            'address' => 'required',
            'phone' => 'required',
            'photo' => 'required|image'
        ]);

        $photo = $request->photo;
        $newphoto = time().$photo->getClientOriginalName();
        //لدالة لوقت بتجيب وقت اضافة الصورة
        //والدالة التانية بتفصل الاسم عن الامتداد وبلزق الاسم مع الوقت
        $photo->move('uploads/stores', $newphoto);




        $store=store::create($request->except('photo') + [
            'photo' => 'uploads/stores/' . $newphoto
                         ]);

        $store->tags()->attach($request->tags);

        return redirect()
        ->route('store.index')
        ->with('success', 'Store create successfully.');
    }


    public function show($id)
    {
        $store = store::find($id);

        return view('store.show', compact('store'));
    }


    public function edit($id)
    {
        $users = User::all();
        $tags = tag::all();
        $areas = area::all();


      if($tags->count() == 0)
    {
return redirect()->route('tag.create');
    }

if($areas->count() == 0)
    {
return redirect()->route('area.create');
    }

        $store = store::find($id);

        return view('store.edit')
        ->with('store', $store)
        ->with('areas', $areas)
        ->with('tags', $tags)
        ->with('users', $users);
    }

    public function update(Request $request,$id)
    {
        $store = store::find($id);
        $this->validate($request, [
            'name' => 'required',
            'area_id' => 'required',
            'tags' => 'required',
            'address' => 'required',
            'phone' => 'required',
            'photo' => 'required|image'
        ]);
        //dd($request->all());

        if ($request->has('photo')) {
            $photo = $request->photo;
            $newphoto = time() . $photo->getClientOriginalName();
            // عم يعطيني اسم الصورة بدون امتداد وعم يدمجها مع الوقت مشان مايصير في تكرار
            $photo->move('uploads/stores', $newphoto);
        }

        $store->update($request->except('photo') + [
            'photo' => 'uploads/stores/' . $newphoto
                         ]);

        $store->save();


        $store->tags()->sync($request->tags); // مشان يعدل كل التاغات ويخزنها

        return redirect()
        ->route('store.index')
        ->with('success', 'edit store  successfully');

    }

    public function destroy($id)
    {
        store::find($id)->delete();
        return redirect()->route('store.index')->with('success', 'Store delete successfully.');
    }

}

resources/views/store/create.blade.php
@extends('layouts.master')
@section('title')
    Create store
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
@stop

@section('content')
    <div class="container">
        <div class="justify-content-center">
            @if (count($errors) > 0)
                <div class="alert alert-danger">
                    <strong>Opps!</strong> Something went wrong, please check below errors.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <!-- head -->
            <div class="breadcrumb-header justify-content-between">
                <div class="my-auto">
                    <div class="d-flex">
                        <h4 class="content-title mb-0 my-auto">Manger store</h4><span
                            class="text-muted mt-1 tx-13 mr-2 mb-0">/
                            store create</span>
                    </div>
                </div>
                <div class="d-flex my-xl-auto right-content">
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-info btn-icon ml-2"><i
                                class="mdi mdi-filter-variant"></i></button>
                    </div>
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-danger btn-icon ml-2"><i class="mdi mdi-star"></i></button>
                    </div>
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-warning  btn-icon ml-2"><i
                                class="mdi mdi-refresh"></i></button>
                    </div>
                    <div class="mb-3 mb-xl-0">
                        <div class="btn-group dropdown">
                            <button type="button" class="btn btn-primary">14 Aug 2019</button>
                            <button type="button" class="btn btn-primary dropdown-toggle dropdown-toggle-split"
                                id="dropdownMenuDate" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <span class="sr-only">Toggle Dropdown</span>
                            </button>
                            <div class="dropdown-menu dropdown-menu-left" aria-labelledby="dropdownMenuDate"
                                data-x-placement="bottom-end">
                                <a class="dropdown-item" href="#">2015</a>
                                <a class="dropdown-item" href="#">2016</a>
                                <a class="dropdown-item" href="#">2017</a>
                                <a class="dropdown-item" href="#">2018</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- head -->

            <div class="card">
                <div class="card-body">
                    <form action="{{ route('store.store') }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        <div class="form-group">

                            <select name="area_id" id="area_id" class="form-control">
                                <option selected hidden="" disabled="" value="default">Select the city</option>
                                @foreach ($areas as $area)
                                    <option value="{{ $area->id }}">{{ $area->name }}</option>
                                @endforeach
                            </select>

                        </div>



                        <div class="form-group">

                            <select name="user_id" id="user_id" class="form-control">
                                <option selected hidden="" disabled="" value="default">Select the user</option>
                                @foreach ($users as $user)
                                @if (is_null($user->store)&&$user->hasRole('store'))


                                <option value="{{ $user->id }}">{{ $user->name }}</option>



                                @endif
                                @endforeach
                            </select>

                        </div>


                        <div class="form-group" id="accordionExample">

                            <div class="accordion-item">
                                <h2 class="accordion-header" id="headingTwo">
                                    <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse"
                                        data-bs-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
                                        Tags </button>
                                </h2>
                                <div id="collapseTwo" class="accordion-collapse collapse" aria-labelledby="headingTwo"
                                    data-bs-parent="#accordionExample">
                                    <div class="accordion-body">

                                        <input type="checkbox"   id="select-all">

                                        <label for="select-all" style="color: blue;">select-all</label>


                                        <div class="container">
                                            <div class="row">
                                                @foreach ($tags as $item)
                                                    <div class="col-lg-3">
                                                        <input type="checkbox" name="tags[]" id="{{ $item->name }}"
                                                            value="{{ $item->id }}">
                                                        <label for="{{ $item->name }}"
                                                            style="color: tomato;">{{ $item->name }}</label>

                                                    </div>
                                                @endforeach
                                            </div>
                                        </div>

                                    </div>
                                </div>
                            </div>

                        </div>


                        <div class="form-group">

                            <input type="text" class="form-control" name="name" placeholder="Name"
                                value="{{ old('name') }}">
                        </div>

                        <div class="form-group">

                            <input type="text" class="form-control" name="address" placeholder="Address"
                                value="{{ old('address') }}">
                        </div>

                        <div class="form-group">

                            <input type="text" class="form-control" name="phone" placeholder="phone"
                                value="{{ old('phone') }}">
                        </div>

                        <div class="form-group ml-100">

                            <div class="form-group">
                                <input name="photo" class="form-control" type="file" id="formFile"
                                    value="{{ old('photo') }}">
                            </div>
                        </div>

                        <div class="card-header">
                            <button type="submit" class="btn btn-primary">Submit</button>
                            <a class="btn btn-danger" href="{{ route('store.index') }}">Back</a>
                        </div>

                    </form>

                </div>



            </div>
        </div>
    </div>
    </div>
@endsection





@section('js')

    <script>
 document.getElementById('select-all').onclick = function() {
    var checkboxes = document.querySelectorAll('input[type="checkbox"]');
    for (var checkbox of checkboxes) {
        checkbox.checked = this.checked;
    }
}
    </script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>


    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.10.2/dist/umd/popper.min.js"
        integrity="sha384-7+zCNj/IqJ95wo16oMtfsKbZ9ccEh31eOz1HGyDuCQ6wgnyJNSYdrPa03rtR1zdB" crossorigin="anonymous">
    </script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.min.js"
        integrity="sha384-QJHtvGhmr9XOIpI6YVutG+2QOK9T+ZnN4kzFN1RtK3zEFEIsxhlmWl5/YESvpZ13" crossorigin="anonymous">
    </script>

@endsection

resources/views/store/edit.blade.php
@extends('layouts.master')
@section('title')
    Edit store
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
@stop

@section('content')
    <div class="container">
        <div class="justify-content-center">
            @if (count($errors) > 0)
                <div class="alert alert-danger">
                    <strong>Opps!</strong> Something went wrong, please check below errors.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <div style="margin-bottom: 50px;margin-top: 50px">
                <div class="d-flex">
                    <h4 class="content-title mb-0 my-auto">Manger store</h4><span class="text-muted mt-1 tx-13 mr-2 mb-0">/
                        store Edit</span>
                </div>
            </div>

            <div class="card">
                <div class="card-body">
                    <form action="{{ route('store.update', $store->id) }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')

                        <div class="form-group">
                            <label class="form-label">area:</label>

                            <select name="area_id" id="area_id" class="form-control">
                                <option selected hidden="" disabled="" value="default">Select the area</option>
                                @foreach ($areas as $area)
                                    <option value="{{ $area->id }}"
                                        {{ $area->id == $store->area_id ? 'selected' : '' }}>{{ $area->name }}</option>
                                @endforeach

                            </select>

                        </div>

                        <div class="form-group">
                            <label class="form-label">user:</label>

                            <select name="user_id" id="user_id" class="form-control">
                                <option selected hidden="" disabled="" value="default">Select the user</option>
                                @foreach ($users as $user)
                                    @if (is_null($user->store) && $user->hasRole('store'))
                                        <option value="{{ $user->id }}"
                                            {{ $user->id == $store->user_id ? 'selected' : '' }}>{{ $user->name }}
                                        </option>
                                    @endif
                                @endforeach
                            </select>

                        </div>

                        <div class="form-group" id="accordionExample">

                            <div class="accordion-item">
                                <h2 class="accordion-header" id="headingTwo">
                                    <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse"
                                        data-bs-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
                                        Tags </button>
                                </h2>
                                <div id="collapseTwo" class="accordion-collapse collapse" aria-labelledby="headingTwo"
                                    data-bs-parent="#accordionExample">
                                    <div class="accordion-body">

                                        <input type="checkbox" id="select-all">

                                        <label for="select-all" style="color: blue;">select-all</label>


                                        <div class="container">
                                            <div class="row">
                                                @foreach ($tags as $item)
                                                    <div class="col-lg-3">
                                                        <input type="checkbox" name="tags[]" id="{{ $item->name }}"
                                                            value="{{ $item->id }}">
                                                        <label for="{{ $item->name }}"
                                                            style="color: tomato;">{{ $item->name }}</label>

                                                    </div>
                                                @endforeach
                                            </div>
                                        </div>

                                    </div>
                                </div>
                            </div>

                        </div>

                        <div class="form-group">
                            <label class="form-label">Name:</label>

                            <input type="text" class="form-control" name="name" placeholder="store"
                                value="{{ old('name', $store->name) }}">
                        </div>

                        <div class="form-group">
                            <label class="form-label">Photo:</label>
                            <input type="file" class="form-control" name="photo">
                        </div>

                        <div class="form-group">
                            <label class="form-label">address:</label>

                            <input type="text" class="form-control" name="address" placeholder="Address"
                            value="{{ old('address', $store->address) }}">
                        </div>

                        <div class="form-group">
                            <label class="form-label">phone:</label>

                            <input type="text" class="form-control" name="phone" placeholder="phone"
                            value="{{ old('phone', $store->phone) }}">
                        </div>



                        <div class="card-header">
                            <button type="submit" class="btn btn-primary">Submit</button>
                            <a class="btn btn-danger" href="{{ route('store.index') }}">Back</a>
                        </div>



                    </form>


                </div>
            </div>
        </div>
    </div>
@endsection


@section('js')

    <script>
        document.getElementById('select-all').onclick = function() {
            var checkboxes = document.querySelectorAll('input[type="checkbox"]');
            for (var checkbox of checkboxes) {
                checkbox.checked = this.checked;
            }
        }
    </script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>


    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.10.2/dist/umd/popper.min.js"
        integrity="sha384-7+zCNj/IqJ95wo16oMtfsKbZ9ccEh31eOz1HGyDuCQ6wgnyJNSYdrPa03rtR1zdB" crossorigin="anonymous">
    </script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.min.js"
        integrity="sha384-QJHtvGhmr9XOIpI6YVutG+2QOK9T+ZnN4kzFN1RtK3zEFEIsxhlmWl5/YESvpZ13" crossorigin="anonymous">
    </script>

@endsection

resources/views/store/show.blade.php
@extends('layouts.master')
@section('title')
Show Store
@stop
@section('content')
    <div class="container">
        <div class="justify-content-center">
            @if (\Session::has('success'))
                <div class="alert alert-success">
                    <p>{{ \Session::get('success') }}</p>
                </div>
            @endif


            <!-- head -->
            <div class="breadcrumb-header justify-content-between">
                <div class="my-auto">
                    <div class="d-flex">
                        <h4 class="content-title mb-0 my-auto"> Manger stores</h4><span
                            class="text-muted mt-1 tx-13 mr-2 mb-0">/ Show stores</span>
                    </div>
                </div>
                <div class="d-flex my-xl-auto right-content">
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-info btn-icon ml-2"><i
                                class="mdi mdi-filter-variant"></i></button>
                    </div>
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-danger btn-icon ml-2"><i class="mdi mdi-star"></i></button>
                    </div>
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-warning  btn-icon ml-2"><i
                                class="mdi mdi-refresh"></i></button>
                    </div>
                    <div class="mb-3 mb-xl-0">
                        <div class="btn-group dropdown">
                            <button type="button" class="btn btn-primary">14 Aug 2019</button>
                            <button type="button" class="btn btn-primary dropdown-toggle dropdown-toggle-split"
                                id="dropdownMenuDate" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <span class="sr-only">Toggle Dropdown</span>
                            </button>
                            <div class="dropdown-menu dropdown-menu-left" aria-labelledby="dropdownMenuDate"
                                data-x-placement="bottom-end">
                                <a class="dropdown-item" href="#">2015</a>
                                <a class="dropdown-item" href="#">2016</a>
                                <a class="dropdown-item" href="#">2017</a>
                                <a class="dropdown-item" href="#">2018</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- head -->

            <div class="card">

                <div class="card-body">
                    <div class="lead">
                        <strong>id:</strong>
                        {{ $store->id }}
                    </div>
                    <div class="lead">
                        <strong>Name:</strong>
                        {{ $store->name }}
                    </div>
                    <div class="lead">
                        <strong>area:</strong>
                        {{$store->area_name}}
                    </div>
                    <div class="lead">
                        <strong>address:</strong>
                        {{  $store->address }}
                    </div>
                    <div class="lead">
                        <strong>phone:</strong>
                        {{  $store->phone }}
                    </div>
                    <div class="lead">
                        <strong>photo:</strong>
                        <img style="width: 200px;height:100px" src="{{$store->photo }}"
                        alt="erorr">
                    </div>

                    <td></td>
                    <td></td>
                    <td> {{ $store->name }}</td>
                    <td> </td>
                    <td> </td>
                    <td></td>

                    <div class="card-header">
                        <span class="float-right">
                            <a class="btn btn-danger" href="{{ route('store.index') }}">Back</a>
                        </span>
                    </div>

                </div>
            </div>
        </div>
    </div>
@endsection